--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2i
--  \   \         Application : ISE
--  /   /         Filename : sysmon_test.vhw
-- /___/   /\     Timestamp : Wed Jul 11 16:57:31 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: sysmon_test
--Device: Xilinx
--

LIBRARY IEEE;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE IEEE.STD_LOGIC_1164.All;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE STD.TEXTIO.ALL;

ENTITY sysmon_test IS
END sysmon_test;

ARCHITECTURE testbench_arch OF sysmon_test IS
    COMPONENT v5_sysmon
        PORT (
            clk : In STD_LOGIC;
            Vccaux : Out STD_LOGIC_VECTOR (9 DownTo 0);
            busy : Out STD_LOGIC;
            alarm : Out STD_LOGIC
        );
    END COMPONENT;

    SIGNAL clk : STD_LOGIC := '0';
    SIGNAL Vccaux : STD_LOGIC_VECTOR (9 DownTo 0) := "0000000000";
    SIGNAL busy : STD_LOGIC := '0';
    SIGNAL alarm : STD_LOGIC := '0';

    constant PERIOD : time := 20 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 0 ns;

    BEGIN
        UUT : v5_sysmon
        PORT MAP (
            clk => clk,
            Vccaux => Vccaux,
            busy => busy,
            alarm => alarm
        );

        PROCESS    -- clock process for clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                WAIT FOR 60020 ns;

            END PROCESS;

    END testbench_arch;

