--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2i
--  \   \         Application : ISE
--  /   /         Filename : sysmon_test.vhw
-- /___/   /\     Timestamp : Mon Jul 09 14:14:11 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: sysmon_test
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
library UNISIM;
use UNISIM.VComponents.all;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY sysmon_test IS
END sysmon_test;

ARCHITECTURE testbench_arch OF sysmon_test IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT toplevel
        PORT (
            clk : In std_logic;
            Vccaux : Out std_logic_vector (9 DownTo 0);
            busy : Out std_logic;
            alarm : Out std_logic
        );
    END COMPONENT;

    SIGNAL clk : std_logic := '0';
    SIGNAL Vccaux : std_logic_vector (9 DownTo 0) := "0000000000";
    SIGNAL busy : std_logic := '0';
    SIGNAL alarm : std_logic := '0';

    constant PERIOD : time := 20 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 0 ns;

    BEGIN
        UUT : toplevel
        PORT MAP (
            clk => clk,
            Vccaux => Vccaux,
            busy => busy,
            alarm => alarm
        );

        PROCESS    -- clock process for clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                WAIT FOR 60020 ns;

            END PROCESS;

    END testbench_arch;

