----------------------------------------------------------------------------------
--
-- Author:     Xilinx
-- Date:       July 11th 2007 $
-- Design:     Virtex-5 System Monitor VHDL example instantiation 
-- 
-- System Monitor instantiation by hand using the Language Template
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


library UNISIM;
use UNISIM.VComponents.all;

entity toplevel is
    Port (clk : in  STD_LOGIC;
          Vccaux : out  STD_LOGIC_VECTOR (9 downto 0);
          busy : out  STD_LOGIC;
			 alarm : out  STD_LOGIC);
end toplevel;


architecture Behavioral of toplevel is
signal dobus : std_logic_vector(15 downto 0);
signal channel_int : std_logic_vector(6 downto 0);
signal channel: std_logic_vector(4 downto 0);
signal alm: std_logic_vector(2 downto 0);
signal eos: std_logic;


begin

-- bring out 10-bit (MSB justified) version of DO bus
Vccaux <= dobus(15 downto 6);
-- Connect ALM[2] (Vccaux alarm) to ouput
alarm <= alm(2);
-- Connect channel output to DRP DADDR inputs and set MSBs to 0
channel_int <= "00" & channel;

 my_sysmon : SYSMON
 	generic map(
		INIT_40 => X"0000", -- Configuration register 0
      INIT_41 => X"20C7", -- Configuration register 1
      INIT_42 => X"0A00", -- Configuration register 2
      INIT_43 => X"0000", -- Test register 0
      INIT_44 => X"0000", -- Test register 1
      INIT_45 => X"0000", -- Test register 2
      INIT_46 => X"0000", -- Test register 3
      INIT_47 => X"0000", -- Test register 4
      INIT_48 => X"0401", -- Sequence register 0
      INIT_49 => X"0000", -- Sequence register 1
      INIT_4A => X"0000", -- Sequence register 2
      INIT_4B => X"0000", -- Sequence register 3
      INIT_4C => X"0000", -- Sequence register 4
      INIT_4D => X"0000", -- Sequence register 5
      INIT_4E => X"0000", -- Sequence register 6
      INIT_4F => X"0000", -- Sequence register 7
      INIT_50 => X"0000", -- Alarm limit register 0
      INIT_51 => X"0000", -- Alarm limit register 1
      INIT_52 => X"E000", -- Alarm limit register 2
      INIT_53 => X"0000", -- Alarm limit register 3
      INIT_54 => X"0000", -- Alarm limit register 4
      INIT_55 => X"0000", -- Alarm limit register 5
      INIT_56 => X"CAAA", -- Alarm limit register 6
      INIT_57 => X"0000", -- Alarm limit register 7		
		SIM_MONITOR_FILE => "vccaux_alarm.txt" --Stimulus file for analog simulation
	)
		
port map ( 
		DCLK  => clk,
		DWE => '0',
		DEN => eos,
		DADDR => channel_int,
		DO => dobus,
		CHANNEL => channel,
		EOS => eos,
		BUSY => busy,
		ALM => alm,
		RESET=> '0',
		CONVST => '0',
		CONVSTCLK => '0',
		DI => "0000000000000000",
		VAUXN => "0000000000000000",
		VAUXP=> "0000000000000000",
		VN => '0',
		VP => '0'
	);
end Behavioral;

